# TP Loto

Énoncé du TP : [https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/](https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/)

## Question Loto 1 : Quels sont les signaux à renseigner dans la liste de sensibilité (si vous utilisez un process explicite) ?

Considering that an sensitivity list is a list of input signals, the signals are {I_0, I_1, I_2, I_3, I_4, I_5, I_sel}.

## Question Loto 2 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ?

If the test is incomplete, some behaviors of the circuit may not be verified. This can lead to errors, where the output produces an incorrect or unexpected result, which is serious.
For example, if the number of bits are bigger then expected it can give bugs.

## Question Loto 3 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.

![image](q2.png)

Since we can see by the simulation that all the numbers from 0 to 5 were printed, it proves that our code is working as expected, so the simulation is important to validate the module.
Despite that, a line to handle all cases that were not explicitly specified in the previous conditions should be considered, as ""0110000" when others;" in one of the other parts of the code.

## Question Loto 4 : Quel(s) signal(aux) doit on renseigner dans la liste de sensibilité de ce processus séquentiel ? Pourquoi ?
In this sequential process, the signals in the list of sensibility are {I_clk, I_rsr, I_block}, because they are the input of the code.

## Question Loto 5 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ici ?
Just like in the previous program, if the test in incomplete, maybe we don't get the outputs as expected. Yes, it is serious.

## Question Loto 6 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.
![image](q6.png)
Yes, the test yielded the expected results for the simulations, as shown in the picture.

## Question Loto 7 : Combien de processus avez-vous décris ?
We made 1 process, including all the states.

## Question Loto 8 : De quel(s) type(s) sont-ils
The process described in the code is sequential, as it operates within a process block and responds to events on the I_clk and I_rst signals. 
It implements a finite state machine (FSM), where the current state (`SR_STATE`) transitions based on input signal events, generating the respective outputs.

## Question Loto 9 : Serait-il possible de décrire cette machine d'état de manière différente, en terme de nombre et de type de process ?
Yes, it could be possible. Our implementation uses a single sequential process that handles both the state update (SR_STATE) and the output assignments. But another approach could be made to separate these two parts. Like that, it would be a combinational process.


## Question Loto 10 : Ce test est-il concluant ? Justifiez.


## Question Loto 11 : Le circuit inféré par l’outil est-il conforme à l’attendu ? Sinon, en quoi diffère-t-il et est-ce lié à une erreur de description VHDL ?


## Question Loto 12 : Quelles sont les ressources utilisées sur le FPGA ? En quelle quantité/proportion des ressources disponibles ? Des **LATCHES** sont-ils utilisés ? Est-ce positif ou pas, pourquoi ?


## Question Loto 13 : Le tirage est-il aléatoire pour un humain ? pour une machine ? Justifiez.
